local addon = LibStub("AceAddon-3.0"):GetAddon("SpartanUI");
local module = addon:NewModule("Buffframe");
local minimap = addon:GetModule("Minimap");
----------------------------------------------------------------------------------------------------
do
	module.offset = 0;
	function module:updateBuffOffset() -- handles SpartanUI offset based on setting or fubar / titan
		local fubar,titan,offset = 0,0;
		for i = 1,4 do
			if (_G["FuBarFrame"..i] and _G["FuBarFrame"..i]:IsVisible()) then
				local bar = _G["FuBarFrame"..i];
				local point = bar:GetPoint(1);
				if point == "TOPLEFT" then fubar = fubar + bar:GetHeight(); 	end
			end
		end
		if (_G["TitanPanelBarButton"] and (TitanPanelGetVar("Position") == 1)) then
			local Double = TitanPanelGetVar("DoubleBar")
			local PanelScale = TitanPanelGetVar("Scale") or 1
			local bar = _G["TitanPanelBarButton"]
			titan = titan + (PanelScale * bar:GetHeight());
			if Double == 2 then titan = titan + (PanelScale * bar:GetHeight()); end
		end
		offset = max(fubar + titan,1);
		return offset;
	end
	
	function module:UpdateBuffPosition()
		-- Debug
--		print("update")
		module.offset = module:updateBuffOffset()
		if (minimap.handleBuff == true) then
			BuffFrame:ClearAllPoints();
			BuffFrame:SetPoint("TOPRIGHT",-13,-13-(module.offset));
			ConsolidatedBuffs:ClearAllPoints();
			ConsolidatedBuffs:SetPoint("TOPRIGHT",-13,-13-(module.offset));
		else
			BuffFrame:ClearAllPoints();
			BuffFrame:SetPoint("TOPRIGHT",UIParent,"TOPRIGHT",-205,-13-(module.offset))
			ConsolidatedBuffs:ClearAllPoints();
			ConsolidatedBuffs:SetPoint("TOPRIGHT",UIParent,"TOPRIGHT",-205,-13-(module.offset))
		end
	end
end

function module:OnEnable()
	local BuffHandle = CreateFrame("Frame")
	BuffHandle:SetScript("OnUpdate",function()
		if (InCombatLockdown()) then return; end
		module:UpdateBuffPosition()
	end);
end